<template>
  <china-register v-if="selectedThemeName === 'china'" />
  <!-- <modern-register v-else-if="selectedThemeName === 'modern'" /> -->
  <div v-else class="container m-auto py-10 flex use-new-color-config">
    <div class="w-[1200px] flex-none m-auto bg-background5 rounded-2xl overflow-hidden">
      <div class="h-[64px] flex items-center justify-between py-0 pl-[40px] pr-[16px] bg-background5">
        <h2 class="text-2xl font-semibold text-[var(--primary)]">
          {{ $t("joinnow") }}
        </h2>
        <close-button />
      </div>
      <div class="w-full h-[2px] bg-border"></div>
      <el-col class="w-[400px] bg-background5 rounded-l-2xl h-[654px] overflow-hidden">
        <el-form
          label-position="left"
          class="register-bg py-6 px-10 rounded"
          :rules="formRules"
          :model="formModel"
          ref="formRef"
          status-icon
        >
          <div class="register-form overflow-y-scroll h-[416px]">
            <el-form-item :class="{required : rules.Username.required}" :label="$t('username')" prop="Username">
              <el-input v-model="formModel.Username" id="registerUsername" />
            </el-form-item>
            <el-form-item :class="{required : rules.Password.required}" :label="$t('password')" prop="Password">
              <el-input type="password" v-model="formModel.Password" id="registerPassword" />
            </el-form-item>
            <el-form-item :class="{required : rules.ConfirmPassword.required}" :label="$t('confirm_password')" prop="ConfirmPassword">
              <el-input type="password" v-model="formModel.ConfirmPassword" id="registerConfirmPassword" />
            </el-form-item>
            <el-form-item :class="{required : rules.Currency.required}" :label="$t('currency')" prop="Currency">
              <el-select v-model="formModel.Currency" style="width:100%" :placeholder="$t('select_currency')" :disabled="currencies.length <= 0" id="registerCurrency" class="ol-bg-light" >
                <el-option
                  v-for="currency in currencies"
                  :key="currency.Currency"
                  :label="currency.Currency"
                  :value="currency.Currency"
                />
              </el-select>
            </el-form-item>
            <template v-for="property in availableProperties" :key="property.PropertyName">
              <theme-common-otp-field
                v-if="property.PropertyName === 'Phone'"
                v-model="formModel"
                :label="property.PropertyNameForDisplay"
                :phone-property="property.PropertyName"
                :is-required="rules[property.PropertyName].required"
                :loading="isGettingOtpCode"
                :next-request-in-seconds="nextRequestOtpInSeconds"
                @get-code="onGetVerificationCode"
              ></theme-common-otp-field>
            <el-form-item
              v-else
              :label="property.PropertyNameForDisplay" :prop="property.PropertyName"
              :class="{ required: rules[property.PropertyName].required}">
              <el-select v-if="property.PropertyName === 'Bank'" v-model="formModel.Bank" style="width:100%"
                :placeholder="$t('select_bank')" :disabled="bankOptions.length <= 0" id="registerBank" class="ol-bg-light" >
                <el-option v-if="bankOptions.length <= 0" label="--" value="0" />
                <el-option v-else v-for="bank in bankOptions" :key="bank.Id" :label="bank.BankName" :value="String(bank.Id)"/>
              </el-select>
              <el-radio-group v-else-if="property.PropertyName === 'Gender'" v-model="formModel.Gender" id="registerGender">
                <el-radio label="male">{{ $t('male') }}</el-radio>
                <el-radio label="female">{{ $t('female') }}</el-radio>
              </el-radio-group>
              <el-date-picker v-else-if="property.PropertyName === 'DateOfBirth'" v-model="formModel.DateOfBirth" type="date"
                value-format="YYYY-MM-DD" id="registerDateOfBirth"/>
              <el-input v-else-if="property.PropertyName === 'Mobile'" v-model="formModel[property.PropertyName]" :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')" id="registerMobile"></el-input>
              <el-input v-else-if="property.PropertyName === 'Referral'" :disabled="referralQuery.length"
                v-model="formModel[property.PropertyName]" id="registerReferral"></el-input>
                <el-input v-else-if="property.PropertyName === 'BankAccountName'"
                :disabled="formModel.Bank === '0' || formModel.Bank === ''" v-model="formModel[property.PropertyName]" id="registerBankAccountName"></el-input>
                <el-input v-else-if="property.PropertyName === 'BankAccountNumber'"
                  :disabled="formModel.Bank === '0' || formModel.Bank === ''" v-model="formModel[property.PropertyName]" id="registerBankAccountNumber" 
                  :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')">
                </el-input>
                <el-input v-else v-model="formModel[property.PropertyName]" :id="`register${property.PropertyName}`"></el-input>
            </el-form-item>
            </template>
            <el-form-item v-if="cashAgentQuery.length" :label="$t('agent_name')" prop="AgentName">
              <el-input :disabled="cashAgentQuery.length" v-model="formModel.AgentName" id="registerAgentName" />
            </el-form-item>
            <el-form-item v-if="!reCaptcha.IsHidden && reCaptchaSiteKey !== ''" :class="[isVerified ? 'verify__recaptcha__success' : '']" prop="Recaptcha">
              <re-captcha
                :sitekey="reCaptchaSiteKey"
                :load-recaptcha-script="true"
                id="registerCaptcha"
                @verify="onVerify"
                @error="onRecaptchaError"
                @expired="onRecaptchaError"
              ></re-captcha>
            </el-form-item>
            <el-form-item prop="Captcha" v-if="!clientCaptcha.IsHidden">
              <div class="captcha">
                <captcha
                  :value="formModel.Captcha"
                  @isValid="getCaptchaErrorMsg"
                />
                <el-input type="text" v-model="formModel.Captcha" id="registerCaptchaValidationCode" :placeholder="$t('enter_validation_code')" />
              </div>
            </el-form-item>
          </div>
          <el-divider class="bg-border" />
          <el-button id="registerSubmitBtn" class="w-full rounded" type="primary" :loading="isLoading" round @click="onRegister(formRef)">
            {{ $t('submit') }}
          </el-button>
          <div class="text-center mt-4 fc-text4 text-xs">{{ $t('already_have_an_account') }} ?
            <nuxt-link class="text-primary underline cursor-pointer" to="/login"
              >{{ $t("capital_login") }}
            </nuxt-link>
          </div>
        </el-form>
      </el-col>
      <el-col class="relative w-[800px] h-[654px] flex justify-center items-center right-side ol-bg-light">
        <div class="text-center">
          <div class="w-[752px] h-[504px]">
            <img :src="loginRegister.ImagePath" class="w-full h-full object-contain" />
          </div>
          <div class="text-primary text-2xl font-black mb-1">
            <span>{{ $t('welcome_to') }}</span>
            <template v-if="allowCompany">
              <span class="font-black text-[32px] fc-text4 ml-1">{{
                seoTitle.Text
              }}</span>
            </template>
            <template v-else>
              <span
                v-if="!companyName.IsHidden"
                class="font-black text-[32px] fc-text4 ml-1"
                >{{ companyName.Text }}</span
              >
            </template>
          </div>
          <div class="text-base fc-text4">{{ $t(loginRegister.Text) }}</div>
        </div>
      </el-col>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import { VueRecaptcha } from 'vue-recaptcha';
import useRegister from '@/composables/useRegister';
import { store } from '~~/store';
import { IThemePropertiesFromApi } from '~~/models/companyThemePropertiesRespone';

export default defineComponent({
  components: {
    reCaptcha: VueRecaptcha,
  },
  setup() {
    const themeProperties = computed(
    () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const companyName = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register_company_name"
      )
    );
    const seoTitle = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "seo_title"
      )
    );
    const loginRegister = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register"
      )
    );
    const {
      availableProperties,
      bankOptions,
      currencies,
      formModel,
      formRef,
      formRules,
      onRegister,
      getCaptchaErrorMsg,
      clientCaptcha,
      reCaptcha,
      reCaptchaSiteKey,
      onVerify,
      onRecaptchaError,
      isVerified,
      cashAgentQuery,
      referralQuery,
      isLoading,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    } = useRegister();
    const selectedThemeName = store.state.selectedThemeName;
    const { allowCompany } = commonHelper;
    return {
      loginRegister,
      companyName,
      availableProperties,
      bankOptions,
      currencies,
      formModel,
      formRef,
      formRules,
      onRegister,
      getCaptchaErrorMsg,
      clientCaptcha,
      onVerify,
      reCaptcha,
      reCaptchaSiteKey,
      onRecaptchaError,
      isVerified,
      referralQuery,
      cashAgentQuery,
      isLoading,
      selectedThemeName,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
      seoTitle,
      allowCompany,
    };
  },
});
</script>

<style scoped lang="scss">
.register-form,
.right-side {
  --bg-base-color: var(--background5);
  --bg-opacity: 5%;
}
.el-popper.is-customized {
  width: 200px;
  padding: 6px 12px;
  background: white;
  box-shadow: #747474 0px 0px 5px;
}
.el-popper.is-customized .el-popper__arrow::before {
  background: white;
}
.el-radio-group {
  display: inline-flex;
}
.el-radio-group + :deep(.el-form-item__error) {
  position: absolute;
}
.el-form-item.is-error.verify__recaptcha__success > :where(.el-form-item__content) > :deep(.el-form-item__error) {
  display: none;
}.el-form-item {
  display: block;
  margin-bottom: 16px;
}
:deep(.el-form-item__label) {
  color: var(--text5);
}
.text-primary {
  color: var(--primary);
}
.register-inner {
  display: block;
}
.el-button.is-round {
  border-radius: 4px;
}
.el-divider--horizontal {
  border: 0;
  margin: 24px 0;
}
.register-form::-webkit-scrollbar, body::-webkit-scrollbar {
  width: 5px;
  height: 5px;
}
.register-form::-webkit-scrollbar-thumb, body::-webkit-scrollbar-thumb {
  background: var(--primary);
}
.bg-border {
  background-color: var(--border) !important;
}
:deep(.el-select:hover .el-input__inner) {
  background: var(--background2) !important;
  box-shadow: none !important;
}
:deep(.el-input .el-input__inner) {
  color: var(--text5);
  background: linear-gradient(
      0deg,
      rgba(var(--bg-light-overlay), var(--bg-opacity)),
      rgba(var(--bg-light-overlay), var(--bg-opacity))
    ),
    linear-gradient(0deg, var(--bg-base-color), var(--bg-base-color)) !important;;
}
:deep(.el-input__suffix-inner) {
  gap: 8px;
}
:deep(.el-input__inner::placeholder) {
  color: var(--text5);
  opacity: 0.5;
}
:deep(.el-radio__label)  {
  color: var(--text5);
}
:deep(.el-input.is-disabled .el-input__inner) {
  --el-disabled-bg-color: var(--background5);
  -webkit-text-fill-color: var(--text5);
  opacity: 0.5;
}
:deep(.el-select .el-input .el-select__caret) {
  color: var(--text5);
  opacity: 0.5;
  width: 16px;
  & svg {
    width: 16px;
    height: 16px;
  }
}
</style>
